/***************************************************************************
* Copyright (C)1999 The XAOL Project, All Rights Reserved.                 *
* WWW: http://www.xaol.org/                                                *
***************************************************************************/
// Events.h

#ifndef __EVENTS__
#define __EVENTS__

#include "Modules.h"
#include "AOLSession.h"

typedef enum {
	kConnectEvent,
	kDisconnectEvent,
	kSignOnEvent,
	kSignOffEvent,
	kOtherEvent
} EventType;

typedef void* EventData;

typedef struct XAOLEvent {
	EventType what;
	AOLSession* where;
	EventData data;
} XAOLEvent;
	
typedef void (*XAEventParser) (XAOLEvent event);

XAOLError XAERegister 	(XAEventParser parser);
XAOLError XAEUnregister	(XAEventParser parser);
void	  XAEDispatch	(EventType what, AOLSession* where, EventData data);

#endif __EVENTS__