/***************************************************************************
* Copyright (C)1999 The XAOL Project, All Rights Reserved.                 *
* WWW: http://www.xaol.org/                                                *
***************************************************************************/
// IPTunnel.c

#include "Modules/Plugin.h"
#include "Events.h"
#include "Tokens.h"
#include "AOLStream.h"
#include "DataStream.h"

#include <string.h>
#include <stdio.h>

/*#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>*/

Module* thisModule;

#define kVersion 0.1

void IPParser (XAOLEvent event);
void RequestIP (AOLSession* session);
void SetupIP (AOLSession*, P3* p3, void*);
void DataIn (AOLSession*, P3* p3, void*);

XAOLError Module_Init (Module* module) {
	printf("Tunneling Module Initialized!\n");
	
	thisModule = module;
	snprintf(thisModule->name, kModuleNameLen, "IP Tunnel - Get online through AOL");
	thisModule->version = kVersion;
	thisModule->type = Mod_Plugin;
	
	return (No_Error);
	}

XAOLError Module_Start (Module* module, AOLSession* session) {
	XAOLError error;

	printf("[IT] Module Started!\n");
	error = XAERegister (IPParser);
	
	return (error);
	}
	
void IPParser (XAOLEvent event) {
	printf("[IT] Parser Called!\n");
	
	switch (event.what) {
		case kSignOnEvent:
			printf("Got Sign on Event - sending tokens.\n");
			RequestIP(event.where);
			break;
		
		case kSignOffEvent:
			break;
		
		default:
			break;
		}
	}
	
void RequestIP (AOLSession* session) {
	XAOLError error;
	char ipInitToken[] = {121, 97};
	
	error = PutToken (session, ipInitToken, NULL, 0);
	if (error == No_Error) {
		printf("Tokens sent - awaiting responses.\n");		
		error = AStreamAdd(session, "7961", SetupIP, NULL);
		error = AStreamAdd(session, "7963", DataIn, NULL);
		}
	else {
		printf("Error sending tokens (%i)\n", error);
		// TODO - Error handling
		}
	}

void SetupIP (AOLSession* session, P3* p3, void* data) {
//	DataStream* ds;
//	char hostname[1024];
//	XAOLError error;
//	struct in_addr aolip, dnsip;
	
//	ds = DSNew(p3->data + 2, p3->length - 2, true);
//	if (ds == NULL)
		// TODO - Error handling
	//	return;
	
	printf("[xaol] Got AOL IP Response - Data is\t%s\n\nParsing...", p3->data);
	}

void DataIn (AOLSession* session, P3* p3, void* data) {
	printf("Data in!\n");
	}