/***************************************************************************
* Copyright (C)1999 The XAOL Project, All Rights Reserved.                 *
* WWW: http://www.xaol.org/                                                *
***************************************************************************/
// XErrors.h

#ifndef __XERRORS__
#define __XERRORS__

typedef enum XAOLError {
	// Standard Errors
	No_Error = 0,
	Mem_Error = 1,
	Arg_Error = 2,
	File_Error = 3,
	
	// P3 Errors
	PE_InvalidType = 4,
	PE_InvalidP3 = 5,
	PE_NoDataToAppend = 6,
	PE_BadData = 7,
	PE_DSError = 8,
	PE_PostMessage = 9,
	
	// Data Stream Errors
	DE_InvalidPos = 10,
	DE_InvalidDS = 11,
	
	// AOL Session Errors
	AE_InvalidSession = 12,
	AE_StateError = 13,
	AE_ConnLevelErr = 14,
	AE_InvalidData = 15,
	AE_InvalidPassword = 16,
	AE_SignOnErr = 17,
	
	// Module Errors
	ME_InvalidModule = 18,
	ME_ModuleNotFound = 19,
	ME_InternalError = 20,
	ME_SymbolNotFound = 21,
	ME_NoModuleSupport = 22,
	ME_WrongModuleType = 23,
	
	// List Errors
	LItemNotFound = 24,

	// Token Error
	TNoTokenData = 25
} XAOLError;

#endif __XERRORS__