/***************************************************************************
* Copyright (C)1999 The XAOL Project, All Rights Reserved.                 *
* WWW: http://www.xaol.org/                                                *
***************************************************************************/
// MacOSDebug.h

#ifndef __MAC_DEBUG__
#define __MAC_DEBUG__

#include "XPlatform.h"
#include "XDebug.h"

// Various forms of debugging. Adjust to modify debugging behavior
#define XAOL_DEBUG_DCON 1
#define XAOL_DEBUG_CONSOLE 0
#define XAOL_DEBUG_MACSBUG 0

#if XAOL_DEBUG
	int Debug_Printf (const char* format, ...);
	
	// Define the type of debugging
	#if XAOL_DEBUG_DCON == 1
		#define DEBUG 1
		#define DCON 1
		
		#include "DCon.h"

		#define XAOL_DEBUG_Printf_ if (Debug_GetLevel() > 0) dprintf
		#define XAOL_DEBUG_Print_ if (Debug_GetLevel() > 0) dprintf
		#define XAOL_Assert_(_condition) if (Debug_GetLevel() > 0) dAssert((_condition))
	#endif
	
	#if XAOL_DEBUG_CONSOLE == 1
		/* I advise adjusting the sioux settings to ensure sane behavior when
			using MSL debugging console.
			SBW - 1/6/00
		*/
		#include <SIOUX.h>
		#include <stdio.h>		
		
		#define XAOL_DEBUG_Printf_ if (Debug_GetLevel() > 0) printf
		#define XAOL_DEBUG_Print_ if (Debug_GetLevel() > 0) puts
		#define XAOL_Assert_(_condition) if (Debug_GetLevel() > 0 && !_condition) \
			printf("Condition %s failed!\n", _condition)
	#endif
	
	#if XAOL_DEBUG_MACSBUG == 1		
		#define XAOL_DEBUG_Printf_ if (Debug_GetLevel() > 0) Debug_Printf
		#define XAOL_DEBUG_Print_ if (Debug_GetLevel() > 0) debugstr
		#define XAOL_Assert_(_condition) if (Debug_GetLevel() > 0 && !_condition) \
			Debug_Printf("Condition %s failed!\n", _condition)
	#endif
#else
	#error "Debugging Header Included in Non-Debug Build!"
#endif XAOL_DEBUG
	
#endif __MAC_DEBUG__