/***************************************************************************
* Copyright (C)1999 The XAOL Project, All Rights Reserved.                 *
* WWW: http://xaol.dhs.org/                                                *
***************************************************************************/
// test.c

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "AOLSession.h"
#include "ConnectionTypes.h"
#include "AOLProtocol.h"

//#define XAOL_DEBUG_Print_ puts;

AOLSession* session = NULL;

void StartTest();
void StopTest();
void SignOff();
void SignOn(char*, char*);

void StartTest () {
	XAOLError error;
	
	error = ASInit();
	if (error != No_Error) {
		XAOL_DEBUG_Print_("asinit failed!;g");
		return;
		}
	}
	
void AOLTest (char* sn, char* password) {
	XAOLError error;	
	TCPConnectionData tcpd;
	char* host = /*"americaonline.aol.com"*/"192.168.1.1";
	
	tcpd.port = 5190;
	tcpd.hostname = (char*) malloc(strlen(host));
	snprintf(tcpd.hostname, strlen(host) + 1, "%s", host);
	
	SignOff();
		
	error = ASNew(&session);
	if (error != No_Error) {
		printf("asnew failed! (%i)\n", error);
		return;
		}
		
	error = ASConnect (session, (void*) &tcpd);
	if (error != No_Error) {
		printf("asconnect failed!\n");
		return;
		}
	
	printf("Signing on....\n");
	error = ASSignOn (session, sn, password);
	if (error != No_Error)
		printf("ASSignOn error %i\n", error);
	else
		printf("Welcome to America Online!\n");
	}

void StopTest () {
	XAOLError error;
	
	SignOff();
		
	error = ASShutdown();
	}

void SignOff () {
	XAOLError error;
	
	if (session != NULL) {
		error = ASDisconnect (session);
		if (error != No_Error)
			XAOL_DEBUG_Print_("asdisconnect failed!;g");
		ASDispose(session);
		session = NULL;
		}
	}

int main () {
	char sn[16], password[64];
	XAOLError error;
	Module* module;
	Module* protocol;
	Module* tunnel;
	
	printf("xaol test application - UNIX version initializing...\n");
	printf("Loading the socket connection layer...\n");
	error = MLoad(&module, "SocketModule.so");
	if (error != No_Error) {
		printf("Error loading the module (%i)\n", error);
		return (1);
		}

	error = ASSetConnectionLayer(module);
	if (error != No_Error) {
		printf("An error occurred while setting the connection layer (%i)\n", error);
		return (1);
		}

	printf("Loading the protocol layer...\n");
	error = MLoad(&protocol, "CroallP3.so");
	if (error != No_Error) {
		printf("Error loading the module (%i)\n", error);
		return (1);
		}

	error = APSetProtocol(protocol);
	if (error != No_Error) {
		printf("An error occurred while setting the protocol layer (%i)\n", error);
		return (1);
		}

	error = MLoad(&tunnel, "ip_tunnel.so");
	if (error != No_Error)
		printf("An error occured while loading the tunneling module. (%i)\n", error);
	else
		printf("Successfully loaded the tunneling module.\n");
		
	StartTest();

	printf("Enter your screen name: ");
	scanf("%s", sn);
	printf("Enter your password: ");
	scanf("%s", password);

	AOLTest(sn, password);
	for(;;)
		ASIdle();
		
	return (0);
	}

